/**
  *  \file int/if/iterif.h
  */
#ifndef PCC_V2_INT_IF_ITERIF_H
#define PCC_V2_INT_IF_ITERIF_H

#include "int/context.h"

class IntValue;
class IntArgBlock;
class GObjectType;

IntValue* IFIteratorGet(IntArgBlock& args);

GObjectType* getObjectTypeFromIteratorId(int32_t id);

class IntIteratorContext : public IntSingleContext {
    GObjectType& type;
 public:
    IntIteratorContext(GObjectType& type);
    ~IntIteratorContext();

    // IntContext:
    int32_t     lookup(string_t name);
    void        set(int32_t index, IntValue* value);
    IntValue*   get(int32_t index);
    IntContext* clone();
    GObject*    getObject();
    string_t    toString(bool readable);
    void        store(IntTagNode& sv, Stream& aux);
};

#endif
