/**
  *  \file ui/widgets/framegroup.cc
  *
  *  (c) 2001-2010 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "ui/widgets/framegroup.h"
#include "ui/util.h"

/** \class UIFrameGroup
    \brief Framed Group

    This widget is like UIGroup, but it will draw a "down" frame
    around its child widgets. */

UIFrameGroup::UIFrameGroup(UILayoutManager& lay, int frame)
    : UILayoutableWidget(lay), frame(frame)
{ }

void
UIFrameGroup::drawContent(GfxCanvas& can)
{
    drawFrameDown(can, getExtent());
    can.update(getExtent());
}

void
UIFrameGroup::adjustSize(GfxRect& size, bool to_inner)
{
    if (to_inner)
        size.grow(-frame, -frame);
    else
        size.grow(frame, frame);
}
